                processor 6502
                include "vcs.h"
                include "macro.h"

ARENA_HEIGHT = 69

                SEG.U vars
                ORG $80
    ; DoDraw Graphic Pointers in $87-8a
Player0Ptr:         ds 2    ; used for drawing player0
Player1Ptr:         ds 2    ; used for drawing player1
Player0Draw:        ds 1    ; used for drawing player0
Player1Draw:        ds 1    ; used for drawing player1
TitleColors:	ds 4
Color0: ds 2
Color0Ptr: ds 2
Color1: ds 2
Color1Ptr: ds 2
SpriteXPosition ds 1
ObjectX         ds 2             ; x coordinate
ObjectY			ds 2
GameRunning		ds 1
LivesDisplay:	ds 5
Rand:			ds 1
LiveColor		ds 1
PlayfieldColor		ds 1
Temp			ds 1
ScoreDisplayRight ds 5
ScoreDisplayLeft ds 5
Frame:          ds 1    
Score:          ds 2    
ScoreTimer:		ds 1
DigitOnes:      ds 2    ; stored in $82-83, DigitOnes = Score, DigitOnes+1 = Score+1
DigitTens:      ds 2    ; stored in $84-85, DigitTens = Score, DigitTens+1 = Score+1
Rand16:          ds 1    
EndNoise:		ds 1
OverscanValue:	ds 1
ScoreCounter:   ds 1

ScreenDrawing:	ds 1
Lives:			ds 1

                SEG code
                ORG $F000
				
Random:
        lda Rand
        lsr
 ifconst Rand16
        rol Rand16
 endif
        bcc noeor
        eor #$B4 
noeor 
        sta Rand
 ifconst Rand16
        eor Rand16
 endif
        rts 	
Reset
   ; Clear RAM and all TIA registers
        CLEAN_START      
		
				lda #$1a
				sta LiveColor
				
				lda #$9c
				sta PlayfieldColor

				lda #1
                sta GameRunning	

				lda #$00
				sta Score
				sta Score+1
		
				lda #88
				sta TitleColors+0

				lda #98
				sta TitleColors+1
				sta Rand		
				sta Rand16
				
				lda #$C8
				sta TitleColors+2
				
				lda #30
				sta TitleColors+3
				
TitleScreen:
	 	lda GameRunning
		cmp #2
		beq Main

				lda #$0e
				sta COLUBK	
				
			lda #16
			sta OverscanValue
		
			jsr VerticalSync
			jsr VerticalBlank	
			jsr Kernel
			jsr Overscan1
			jsr Bees_buzzing_at_title_screen
			
				lda INPT4
				bmi TitleScreen
				
StartGame:
				lda #19
				sta OverscanValue				
				
				lda #2
				sta GameRunning
	
				lda #70
				sta ObjectX+0
	
				lda #60
				sta ObjectX+1
	
				lda #49
				sta ObjectY+0	
				sta ObjectY+1
				sta COLUP1
	
Main:
				lda #$00
				sta COLUBK	
		
			jsr VerticalSync
			jsr VerticalBlank	
			jsr PositionObjects		
			jsr Kernel
			jsr Overscan1
	
			jmp Main

Bees_buzzing_at_title_screen:
				lda #06
				sta AUDC0
				sta AUDV0
		
				jsr Random
				and #$0f
				adc #$09
				sta AUDF0
		
				;jsr AddScoreTest
		
				rts

PrepScoreForDisplay:      
        ldx #4
PSFDloop:
        lda Lives   ;Lives digit
        and #$0F
        sta Temp
        asl
        asl
        adc Temp
        sta Temp
        txa
        adc Temp
        tay
        lda DigitFlippedGfx,y
        and #$F0
        sta LivesDisplay,x
        
        lda Score   ; thousandths digit
        and #$F0
        lsr
        lsr
        sta Temp
        lsr
        lsr
        adc Temp    
        sta Temp
        txa
        adc Temp
        tay
        lda DigitFlippedGfx,y
        and #$0F
        sta ScoreDisplayLeft,x
        
        lda Score   ;hundredths digit
        and #$0F
        sta Temp
        asl
        asl
        adc Temp
        sta Temp
        txa
        adc Temp
        tay
        lda DigitFlippedGfx,y
        and #$F0
        ora ScoreDisplayLeft,x
        sta ScoreDisplayLeft,x
        
        lda Score+1   ; tenths digit
        and #$F0
        lsr
        lsr
        sta Temp
        lsr
        lsr
        adc Temp    
        sta Temp
        txa
        adc Temp        
        tay
        lda DigitGfx,y
        and #$F0
        sta ScoreDisplayRight,x
        
        lda Score+1   ;ones digit
        and #$0F
        sta Temp
        asl
        asl
        adc Temp
        sta Temp
        txa
        adc Temp        
        tay
        lda DigitGfx,y
        and #$0F
        ora ScoreDisplayRight,x
        sta ScoreDisplayRight,x        
        
        dex
        bpl PSFDloop
        rts     	

VerticalSync:
        lda #$2        ; DGS - LoaD Accumulator with $82 so D7=1 and D1=1
        ldx #47        ; LoaD X with 49
        sta WSYNC       ; Wait for SYNC (halts CPU until end of scanline)
        sta VSYNC       ; Accumulator D1=1, turns on Vertical Sync signal
        sta VBLANK      ; DGS - turn off video, dump paddles to ground
        stx TIM64T      ; set timer to go off in 41 scanlines (49 * 64) / 76
        sta CTRLPF      ; D1=1, playfield now in SCORE mode
        lda Frame
        and #$3f
        bne VSskip
VSskip: inc Frame       ; increment Frame count

        sta WSYNC   ; Wait for Sync - halts CPU until end of 1st scanline of VSYNC
        lda #$30    ; 
        sta NUSIZ0  ; set missile0 to be 8x
        sta NUSIZ1  ; set missile1 to be 8x
        sta WSYNC   ; wait until end of 2nd scanline of VSYNC
        lda #0      ; LoaD Accumulator with 0 so D1=0
        sta PF0     ; blank the playfield
        sta PF1     ; blank the playfield
        sta PF2     ; blank the playfield
        sta GRP0    ; blanks player0 if VDELP0 was off
        sta GRP1    ; blanks player0 if VDELP0 was on, player1 if VDELP1 was off 
        sta GRP0    ; blanks                           player1 if VDELP1 was on		
        sta VDELP0  ; turn off Vertical Delay
        sta VDELP1  ; turn off Vertical Delay
        sta CXCLR   ; clear collision detection latches
        sta WSYNC   ; wait until end of 3rd scanline of VSYNC
        sta VSYNC   ; Accumulator D1=0, turns off Vertical Sync signal
Sleep12:            ;       jsr here to sleep for 12 cycles        
        rts         ; ReTurn from Subroutine
		
VerticalBlank:    
        jsr Random 
		jsr ProcessJoystick		
		jsr PrepScoreForDisplay
	
AddScoreTest:
		ldx EndNoise
		inx		
		stx EndNoise
	
	 	ldx EndNoise
		cpx #30
		beq TS_Color_change
	
	 	ldx EndNoise
		cpx #60
		beq AddOneToScore
		
		rts
		
ProcessJoystick:
        lda SWCHA       ; fetch state of both joysticks
        
        asl                     ; shift A bits left, D is now in the carry bit
        bcs CheckLeft            ; branch if joystick not held down
        ldy ObjectX+1            ; get the object's Y position
        cpy #133                ; test for bottom of screen
        beq SaveX               ; save Y if we're not at the bottom		
        iny                     ; move it down

SaveX:  sty ObjectX+1            ; save Y

CheckLeft:
        asl                     ; shift A bits left, U is now in the carry bit
        bcs CheckDown    ; branch if joystick not held up
        ldy ObjectX+1            ; get the object's Y position

        cpy #20     ; test for top of screen
        beq SaveX2              ; save Y if we're not at the top
		
	    dey                     ; move it up	
   
SaveX2: sty ObjectX+1            ; save Y

CheckDown:
        asl                     ; shift A bits left, D is now in the carry bit
        bcs CheckUp             ; branch if joystick not held down
        ldy ObjectY+1            ; get the object's Y position
        cpy #18               ; test for bottom of screen
        beq SaveY               ; save Y if we're not at the bottom		
        dey                     ; move it down

SaveY:  sty ObjectY+1            ; save Y

CheckUp:
        asl                     ; shift A bits left, U is now in the carry bit
        bcs DoneWithJoystick    ; branch if joystick not held up
        ldy ObjectY+1            ; get the object's Y position

        cpy #69     ; test for top of screen
        beq SaveY2              ; save Y if we're not at the top
		
	    iny                     ; move it up	
   
SaveY2: sty ObjectY+1            ; save Y

DoneWithJoystick:
        rts		
		
AddOneToScore:
		ldx #0
		stx EndNoise

        sed             ; turn on decimal mode
        clc
        lda Score+1     ; Score+1 holds the Tens and Ones digits
        adc #1          ; add 1 to score
        sta Score+1
        lda Score       ; Score holds the Thousands and Hundreds digits
        adc #0          ; add 0 to this digit, carry will inc by 1 if needed
        sta Score       ;
        cld             ; turn off decimal mode

TS_Color_change:
		lda TitleColors+1
		sta TitleColors+0	

		lda TitleColors+2
		sta TitleColors+1	

		lda TitleColors+3
		sta TitleColors+2	
	
		lda TitleColors+4
		sta TitleColors+3	
	
		jsr Random
		sta TitleColors+4
		
		rts

PositionObjects:
        ldx #1              ; position players 0 and 1
POloop:
        lda #(ARENA_HEIGHT + Beebot_HEIGHT)
        sec
        sbc ObjectY
        sta Player0Draw

        lda ObjectX,x       ; get the Player's X position
        jsr PosObject      ; set coarse X position and fine-tune amount 
			
        dex                 ; DEcrement X
        bpl POloop          ; Branch PLus so we position all Players
        sta WSYNC           ; wait for end of scanline
        sta HMOVE           ; Tell TIA to use fine-tune values to set final X positions
  
    ; Player0Draw = ARENA_HEIGHT + HUMAN_HEIGHT - Y_position
        lda #<(BeebotGFX + Beebot_HEIGHT - 1)
        sec
        sbc ObjectY+0
        sta Player0Ptr
        lda #>(BeebotGFX + Beebot_HEIGHT - 1)
        sbc #0
        sta Player0Ptr+1
		
        lda #<(BeebotColors + Beebot_HEIGHT - 1)   ; DGS33
        sec                                 ; DGS33
        sbc ObjectY+0                       ; DGS33
        sta Color0Ptr                       ; DGS33
        lda #>(BeebotColors + Beebot_HEIGHT - 1)   ; DGS33
        sbc #0                              ; DGS33
        sta Color0Ptr+1                     ; DGS33		
		
    ; Player1Draw = ARENA_HEIGHT + BOX_HEIGHT - Y_position
        lda #(ARENA_HEIGHT + Bees_HEIGHT)
        sec
        sbc ObjectY+1
        sta Player1Draw        
       
    ; Set Player1Ptr to proper value for drawing player1
        lda #<(BeesGFX + Bees_HEIGHT - 1)
        sec
        sbc ObjectY+1
        sta Player1Ptr
        lda #>(BeesGFX + Bees_HEIGHT - 1)
        sbc #0
        sta Player1Ptr+1	

		lda #$0e
		sta COLUP1


		rts
        
PosObject:
        sec
        sta WSYNC
DivideLoop
        sbc #15        ; 2  2 - each time thru this loop takes 5 cycles, which is 
        bcs DivideLoop ; 2  4 - the same amount of time it takes to draw 15 pixels
        eor #7         ; 2  6 - The EOR & ASL statements convert the remainder
        asl            ; 2  8 - of position/15 to the value needed to fine tune
        asl            ; 2 10 - the X position
        asl            ; 2 12
        asl            ; 2 14
        sta.wx HMP0,X  ; 5 19 - store fine tuning of X
        sta RESP0,X    ; 4 23 - set coarse X position of Player
		rts
	
		   
WriteTitle_____:
			jmp WriteTitle
		
Kernel:      
		jsr Random

        sta WSYNC       ; Wait for SYNC (halts CPU until end of scanline)
;---------------------------------------                
        lda INTIM       ; 4  4 - check the timer
        bne Kernel    ; 2  6 - (3 7) Branch if its Not Equal to 0
    ; turn on the display
        sta VBLANK      ; 3  9 - Accumulator D1=0, turns off Vertical Blank signal (image output on)        
		lda #$01          ; 2 11
		sta CTRLPF      ; 3 14 - turn on playfield mirroring
		
		ldx #0
        ldy #ARENA_HEIGHT   ;        init loop counter		
		
ScoreLoop2:
        sta WSYNC
;---------------------------------------
        lda LivesDisplay,x      ; 4  4
        sta PF0                 ; 3  7 - update PF0 for left side of screen
        lda LiveColor                ; 2  9
        sta COLUPF              ; 3 12
        lda ScoreDisplayLeft,x  ; 4 16
        sta PF2                 ; 3 19 - update PF2 for left side of screen
        jsr Sleep12             ;12 31
        lda PlayfieldColor              ; 2 33
        sta COLUPF              ; 3 36
        SLEEP 3                 ; 5 41
        lda ScoreDisplayRight,x ; 4 45
        sta PF2                 ; 3 48 - @48 - update PF2 for right side of screen
        lda #0                  ; 2 50
        sta PF0                 ; 3 53 - update PF0 for right side of screen
        sta WSYNC
;---------------------------------------
        lda LivesDisplay,x      ; 4  4
        sta PF0                 ; 3  7 - update PF0 for left side of screen
        lda LiveColor               ; 2  9
        sta COLUPF              ; 3 12        
        lda ScoreDisplayLeft,x  ; 4 11
        sta PF2                 ; 3 14 - update PF2 for left side of screen
        jsr Sleep12             ;12 26
        lda PlayfieldColor                ; 2 33
        sta COLUPF              ; 3 36
        SLEEP 3                 ; 5 41
        lda ScoreDisplayRight,x ; 4 45
        sta PF2                 ; 3 48 - @48 - update PF2 for right side of screen
        lda #0                  ; 2 50
        sta PF0                 ; 3 53 - update PF0 for right side of screen
        inx                     ; 2 55
        cpx #5                  ; 
        bne ScoreLoop2	   ; 3 58

Rest_of_score_stuff:
;---------------------------------------
        lda #0          ; 2  2
		sta PF1
		sta PF2	
		tax            ; used by Draw_MrCelery loop
        sta WSYNC       ; 3  6 - wait for end of scanline
;---------------------------------------  
		lda #$00
		sta COLUPF	
				
	 	ldx GameRunning
		cpx #1
		beq WriteTitle_____
	
	
		ldy #ARENA_HEIGHT
	
				lda #$00	; don't forget to close this!
				sta AUDV0
	
				lda #$00
				sta COLUBK	  

				lda #$84
				sta COLUPF	 

				lda #0
				sta ScreenDrawing
				
GameBoard0:				
				lda #0
				sta PF0
                sta PF1	
                sta PF2      

				inc ScreenDrawing
				
                lda ScreenDrawing
                cmp #5
                bcc GameBoard0

GameBoard1:
				sta WSYNC		
						
				lda #%00000111
				sta PF2	
	
				lda #%11100000
				sta PF2					
				
				inc ScreenDrawing
				
                lda ScreenDrawing
                cmp #7
                bcc GameBoard1
					
GameBoard2:
				sta WSYNC		
						
				lda #%00000100
				sta PF2	

				lda #%00100000
				sta PF2						
			
				inc ScreenDrawing
				
                lda ScreenDrawing
                cmp #22
                bcc GameBoard2				
						
GameBoard3:    
	            sta WSYNC               ; wait till end of scanline
				lda #0
				sta PF0
                lda #%11111111	
                sta PF1	
                sta PF2      
		
				sta WSYNC
	
				inc ScreenDrawing
		
                lda ScreenDrawing
                cmp #24
                bne GameBoard3				
	
GameBoard4:    
				lda #0
				sta PF0
                lda #%10000000		;
                sta PF1
                lda #%00000000		
                sta PF2      

				jsr DrawTheScreen
		
                lda ScreenDrawing
                cmp #34
                bne GameBoard4		
			
GameBoard5:    
				lda #%11110000
				sta PF0
                lda #%10000000		
                sta PF1
                lda #%00000000		
                sta PF2      			

				jsr DrawTheScreen
		
                lda ScreenDrawing
                cmp #36
                bne GameBoard5				
			
			
GameBoard6:    
				lda #%00010000
				sta PF0
                lda #%10000000		
                sta PF1
                lda #%00000000		
                sta PF2      

				jsr DrawTheScreen
	
                lda ScreenDrawing
                cmp #46
                bne GameBoard6				
					
GameBoard7:    
				lda #%11110000
				sta PF0
                lda #%10000000		
                sta PF1
                lda #%00000000		
                sta PF2      

 				jsr DrawTheScreen
		
                lda ScreenDrawing
                cmp #48
                bne GameBoard7				
			
GameBoard8:    
				lda #0
				sta PF0
                lda #%10000000		;
                sta PF1
                lda #%00000000		
                sta PF2      

   				jsr DrawTheScreen
		
                lda ScreenDrawing
                cmp #68
                bne GameBoard8		
			
GameBoard9:    
				lda #%11110000
				sta PF0
                lda #%10000000		
                sta PF1
                lda #%00000000		
                sta PF2      

				jsr DrawTheScreen
		
                lda ScreenDrawing
                cmp #70
                bne GameBoard9					
			
GameBoard10:    
				lda #%00010000
				sta PF0
                lda #%10000000		
                sta PF1
                lda #%00000000		
                sta PF2      		

				jsr DrawTheScreen
	
                lda ScreenDrawing
                cmp #81
                bne GameBoard10
				
GameBoard11:    
				lda #%11110000
				sta PF0
                lda #%10000000		
                sta PF1
                lda #%00000000		
                sta PF2      

				jsr DrawTheScreen
		
                lda ScreenDrawing
                cmp #83
                bne GameBoard11					
				
GameBoard12:    
				lda #0
				sta PF0
                lda #%10000000		;
                sta PF1
                lda #%00000000		
                sta PF2      

				jsr DrawTheScreen
		
                lda ScreenDrawing
                cmp #85
                bne GameBoard12							
				
GameBoard13:    
	            sta WSYNC               ; wait till end of scanline
				lda #0
				sta PF0
                lda #%11111111		
                sta PF1
                lda #%11111111		
                sta PF2      

				inc ScreenDrawing

                lda ScreenDrawing
                cmp #89
                bne GameBoard13	

GameBoard14:    
	            sta WSYNC               ; wait till end of scanline
				lda #0
				sta PF0
                sta PF1	
                sta PF2      

				inc ScreenDrawing
			
                lda ScreenDrawing
				cmp #133
                bne GameBoard14					
				
				rts
				
DrawTheScreen:				
		inc ScreenDrawing

Draw_sprites_routine:     
        lda #0 
        ;ldy #ARENA_HEIGHT   ;        init loop counter
        sta WSYNC
        ;sta VBLANK          ; 3  3 - turn on video output

ArenaLoop:                  ; - 11 - time of longest path here
        lda #Beebot_HEIGHT-1 ; 2 13 - height of the human graphics, 
        dcp Player0Draw     ; 5 18 - Decrement Player0Draw and compare with height
        bcs DoDrawGrp0      ; 2 20 - (3 21) if Carry is Set then player0 is on current scanline
        lda #0              ; 2 22 - otherwise use 0 to turn off player0
        .byte $2C           ; 4 26 - $2C = BIT with absolute addressing, trick that
                            ;        causes the lda (Player0Ptr),y to be skipped
DoDrawGrp0:                 ;   21 - from bcs DoDrawGRP0
        lda (Player0Ptr),y  ; 5 26 - load the shape for player0
        tax                 ; 2 28 - save in X for update during Horizontal Blanking
        lda (Color0Ptr),y   ; DGS33   
        sta Color0          ; DGS33  

        lda #Beebot_HEIGHT-1   ; 2 30 - height of the box graphics, subtract 1 due to starting with 0
        dcp Player1Draw     ; 5 35 - Decrement Player1Draw and compare with height
        bcs DoDrawGrp1      ; 2 37 - (3 38) if Carry is Set, then player1 is on current scanline
        lda #0              ; 2 39 - otherwise use 0 to turn off player1
        .byte $2C           ; 4 43 - $2C = BIT with absolute addressing, trick that
                            ;        causes the lda (Player1Ptr),y to be skipped
DoDrawGrp1:                 ;   38 - from bcs DoDrawGrp1
        lda (Player1Ptr),y  ; 5 43 - load the shape for player1
        sta WSYNC           ; 3 46/0 - halts CPU until start of next scanline
		
        stx GRP0            ; 3  3 - draw the human
		sta GRP1            ; 3  6 - draw the box
	
       lda Color0          ; DGS33
       sta COLUP0          ; DGS33
	

        dey                 ; 2  8 - update loop counter

StopDrawing
		rts						
	
WriteTitle:   
				sta CTRLPF      ; 3  5 - turn off SCORE mode
 
	            sta WSYNC               ; wait till end of scanline
 
				lda #$0e
				sta COLUBK	  

				lda #0
				sta PF0				
				sta PF1
				sta PF2
                inx
                cpx #40
                bne WriteTitle
				
Title1:    
	            sta WSYNC               ; wait till end of scanline
				lda #%10000000
				sta PF0
                lda #%00101010		; k i l
                sta PF1
                lda #%01101101		; r e l
                sta PF2      
				sleep 21
				lda #0
				sta PF0				
                lda #%11110110		;  b e
                sta PF1
				lda #%00011011		; s e 
				sta PF2
				
                inx
                cpx #43
                bne Title1
		
Title2:
				sta WSYNC              ; wait till end of scanline
				lda #%10000000
				sta PF0	
                lda #%01000010		; k i l
                sta PF1
                lda #%00101101		; r e l
                sta PF2      
				sleep 21
                lda #%10010110		;   b e
                sta PF1
				lda #%00001011		; s e 
				sta PF2
  				lda #0
				sta PF0           
			 
                inx
                cpx #46
                bne Title2				

Title3:
				sta WSYNC
				lda #%10000000
				sta PF0				
                lda #%10001010		; k i l
                sta PF1
                lda #%00101101		; r e l
                sta PF2   
				sleep 21
                lda #%11100110		;   b e
                sta PF1
      
				lda #%00011011		; s e 
				sta PF2
				lda #0
				sta PF0				
				
                inx
                cpx #49
                bne Title3
	
Title4:
				sta WSYNC
				lda #%10000000
				sta PF0					
				
                lda #%01001010		; k i l
                sta PF1
                lda #%00100101		; r e l
                sta PF2  
				sleep 21
                lda #%10010100		;   b e
                sta PF1
				lda #%00010001		; s e 
				sta PF2
				lda #0
				sta PF0				

                inx
                cpx #52
                bne Title4

Title5:
				sta WSYNC		
						
				lda #%10000000
				sta PF0					
						
                lda #%00101010		; k i l
                sta PF1
                lda #%00101101		; r e l
                sta PF2  
				sleep 21
				lda #0
				sta PF0						
                lda #%11110110		;   b e
                sta PF1
				lda #%00011011		;  s e
				sta PF2
		
                inx
                cpx #55
                bne Title5

Title5a:
				sta WSYNC	
					
				lda #0		
				sta PF0					
				sta PF1		
				sta PF2	
	
                inx
                cpx #60
                bne Title5a

				lda TitleColors+0
				sta COLUPF

Title6:
				sta WSYNC		
						
				lda #255		
				sta PF1		
				sta PF2	
				
				lda #%10001010
				sta PF0	
				
				sleep 22
		
				lda #255		
				sta PF1			
				sta PF0	
				
				lda #%00011111
				sta PF2	
		
                inx
                cpx #70
                bne Title6
		
		
				
Title7:
				sta WSYNC		
			
				lda TitleColors+1
				sta COLUPF	
			
				lda #0		
				sta PF0
			
				lda #%00001111
				sta PF1	

				lda #255				
				sta PF2

				sleep 21
		
				lda #255	
				sta PF0
				sta PF1
				
				lda #0
				sta PF2

                inx
                cpx #80
                bne Title7
				
				lda TitleColors+2
				sta COLUPF		
				
Title8:
				sta WSYNC	
				
				lda #0		
				sta PF1
				sta PF0
				
				lda #255
				sta PF2	

				sleep 21
		
				lda #255	
				sta PF0

				lda #%11110000
				sta PF1	

				lda #0
				sta PF2				
			
                inx
                cpx #90
                bne Title8		

				lda TitleColors+3
				sta COLUPF	

Title9:
				sta WSYNC	
				
				lda #0		
				sta PF0
				sta PF1	
				
				lda #%11110000
				sta PF2

				sleep 24
		
				lda #255	
				sta PF0

				lda #0
				sta PF1	
				sta PF2			
			
                inx
                cpx #100
                bne Title9			

Title10:    
	            sta WSYNC               ; wait till end of scanline

                lda #0
                sta PF0
                sta PF1      
				sta PF2

				inx

                cpx #196
                bne Title10		

				rts
					
Overscan1:
        sta WSYNC   ; Wait for SYNC (start of next scanline)
        lda #2      ; LoaD Accumulator with 2
        sta VBLANK  ; STore Accumulator to VBLANK, D1=1 turns image output off
        lda OverscanValue
        sta TIM64T  ; set timer for end of Overscan
    	
OSwait:
        sta WSYNC
        bit TIMINT
        bpl OSwait  ; wait for the timer to denote end of Overscan	

		rts
		
DigitGfx:
        .byte %01110111
        .byte %01010101
        .byte %01010101
        .byte %01010101
        .byte %01110111
        
        .byte %00100010
        .byte %01100110
        .byte %00100010
        .byte %00100010       
        .byte %01110111
        
        .byte %01110111
        .byte %00010001
        .byte %01110111
        .byte %01000100
        .byte %01110111
        
        .byte %01110111
        .byte %00010001
        .byte %00110011
        .byte %00010001
        .byte %01110111
        
        .byte %01010101
        .byte %01010101
        .byte %01110111
        .byte %00010001
        .byte %00010001
        
        .byte %01110111
        .byte %01000100
        .byte %01110111
        .byte %00010001
        .byte %01110111
           
        .byte %01110111
        .byte %01000100
        .byte %01110111
        .byte %01010101
        .byte %01110111
        
        .byte %01110111
        .byte %00010001
        .byte %00010001
        .byte %00010001
        .byte %00010001
        
        .byte %01110111
        .byte %01010101
        .byte %01110111
        .byte %01010101
        .byte %01110111
        
        .byte %01110111
        .byte %01010101
        .byte %01110111
        .byte %00010001
        .byte %01110111

DigitFlippedGfx:
        .byte %11101110
        .byte %10101010
        .byte %10101010
        .byte %10101010
        .byte %11101110
        
        .byte %01000100
        .byte %01100110
        .byte %01000100
        .byte %01000100       
        .byte %11101110
        
        .byte %11101110
        .byte %10001000
        .byte %11101110
        .byte %00100010
        .byte %11101110
        
        .byte %11101110
        .byte %10001000
        .byte %11001100
        .byte %10001000
        .byte %11101110
        
        .byte %10101010
        .byte %10101010
        .byte %11101110
        .byte %10001000
        .byte %10001000
        
        .byte %11101110
        .byte %00100010
        .byte %11101110
        .byte %10001000
        .byte %11101110
           
        .byte %11101110
        .byte %00100010
        .byte %11101110
        .byte %10101010
        .byte %11101110
        
        .byte %11101110
        .byte %10001000
        .byte %10001000
        .byte %10001000
        .byte %10001000
        
        .byte %11101110
        .byte %10101010
        .byte %11101110
        .byte %10101010
        .byte %11101110
        
        .byte %11101110
        .byte %10101010
        .byte %11101110
        .byte %10001000
        .byte %11101110
			
BeebotGFX:
		.byte #%01101100
		.byte #%00101000
		.byte #%00101000				
		.byte #%01111100		
		.byte #%10000010	
		.byte #%10000010	
		.byte #%01111100	
		.byte #%11000110	
		
Beebot_HEIGHT = * - BeebotGFX


BeesGFX:
		.byte #%00010010
		.byte #%10010100
		.byte #%00101000			
		.byte #%01001010		
		.byte #%01000100
		.byte #%10010100
		.byte #%00101000			
		.byte #%01001010	
		
Bees_HEIGHT = * - BeesGFX

BeebotColors:
		.byte #$0e
		.byte #$0e
		.byte #$0e
		.byte #$34
		.byte #$34
		.byte #$34
		.byte #$34
		.byte #$34
		
BeebotColors2:
		.byte #$0e
		.byte #$0e
		.byte #$0e
		.byte #$8a
		.byte #$8a
		.byte #$8a
		.byte #$8a
		.byte #$8a

;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ;; Function to check for free space at end of cart.
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	echo "------", [$FFFA - *]d, "bytes free before End of Cartridge"

            ORG $FFFA

InterruptVectors
            .word Reset			        ; NMI
            .word Reset         ; RESET
            .word Reset           ; IRQ

      END